问题:
LeetCode-1
English:
Given an array of integers, return indices of the two numbers such that they add up to a specific target.
You may assume that each input would have exactly one solution, and you may not use the same element twice.
Example:
Given nums = [2, 7, 11, 15], target = 9,
Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].
中文:
给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。
示例:
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
解法:
使用HashMap同时记录下数字和位置,用目标数字循环去减数组内部的数,并遍历哈希表看看减的结果是否已经在哈希表内,如果在,则可以直接输出了。
实现代码(java版)
if (nums == null || nums.length < 2) {
return new int[] { -1, -1 };
}
int[] des = new int[] { -1, -1 };
HashMap map = new HashMap();
for (int i = 0; i < nums.length; i++) {
if (map.containsKey(target - nums[i])) {
des[0] = map.get(target - nums[i]);
des[1] = i;
break;
}
map.put(nums[i], i);
}
return des;